#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int main()
{
   bool k= true;
   int   w=0,s=2,x=0,n,t,c[4];
    cin>>n;
   long long int p,q,a[n],b[n];
    for(int i=0;i<n;i++)
    {
      cin>>p>>q;
        for(int j=0;j<p;j++) cin>>a[j];
         for(int f=0;f<q;f++) cin>>b[f];
      sort(a,a+p);
       sort(b,b+q);
           while(k==true)
           {
        if(s>a[p-1])
              {
               x=0;
              break;
              }
              w=0;
              for(int u=0;u<p;u++)
              {
                 if(u==0)
                 {
                     t=a[u]%s;
                 }
                  if(u==1)
                 {
              }
                if (a[u]%s != t)
                 {
                    s++;
                     w++;
                   break;
                 }
              }
                   if(w>0)  continue;
              for(int v=0;v<q;v++)
              {
                 if(b[v]%s==t)
                 {
                    s++;
                    w++;
                    break;
                 }
              }
                 if(w>0)
                 {
                    continue;
                 }
                    x++;
                    break;
                 }
       c[i]=x;
        s=2;
        x=0;
        k=true;
    }
    for(int d=0;d<n;d++) cout<<c[d]<<endl;


    return 0;

}